"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class VariantInterpretationLog(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "caseId",
        "groupId",
        "timestamp",
        "user",
        "variantClassification",
        "variantCoordinates",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_8 import reports as reports_6_2_0

        return {
            "comments": reports_6_2_0.UserComment,
            "user": reports_6_2_0.User,
            "variantClassification": reports_6_2_0.GuidelineBasedVariantClassification,
            "variantCoordinates": reports_6_2_0.VariantCoordinates,
            "variantValidation": reports_6_2_0.VariantValidation,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_8 import reports as reports_6_2_0

        return {
            "org.gel.models.report.avro.UserComment": reports_6_2_0.UserComment,
            "org.gel.models.report.avro.User": reports_6_2_0.User,
            "org.gel.models.report.avro.GuidelineBasedVariantClassification": reports_6_2_0.GuidelineBasedVariantClassification,
            "org.gel.models.report.avro.VariantCoordinates": reports_6_2_0.VariantCoordinates,
            "org.gel.models.report.avro.VariantValidation": reports_6_2_0.VariantValidation,
            "org.gel.models.report.avro.VariantInterpretationLog": reports_6_2_0.VariantInterpretationLog,
        }

    __slots__ = [
        "caseId",
        "groupId",
        "timestamp",
        "user",
        "variantClassification",
        "variantCoordinates",
        "Artifact",
        "comments",
        "decisionSupportSystemFilters",
        "variantValidation",
    ]

    def __init__(
        self,
        caseId,
        groupId,
        timestamp,
        user,
        variantClassification,
        variantCoordinates,
        Artifact=None,
        comments=None,
        decisionSupportSystemFilters=None,
        variantValidation=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_2_0.VariantInterpretationLog model.

        :param caseId:
            Interpretation request ID including CIP prefix and version suffix
            (e.g. SAP-1234-1)
        :type caseId: str
        :param groupId:
            GeL group ID. For GMS cases this will be the referral ID. For 100k
            rare disease cases this will be the family ID. For 100k
            cancer cases this will be the participant ID.
        :type groupId: str
        :param timestamp:
            Date of classification. Format YYYY-MM-DD (e.g. 2020-01-31)
        :type timestamp: str
        :param user:
            User who set classification
        :type user: User
        :param variantClassification:
            Guideline-based variant classification
        :type variantClassification: GuidelineBasedVariantClassification
        :param variantCoordinates:
            Variant coordinates
        :type variantCoordinates: VariantCoordinates
        :param Artifact:
            User has marked the variant as an artefact
        :type Artifact: None | boolean
        :param comments:
            User comments attached to this variant in this case
        :type comments: None | list[UserComment]
        :param decisionSupportSystemFilters:
            Filter settings applied at time variant was classified
        :type decisionSupportSystemFilters: None | dict[str, str]
        :param variantValidation:
            Independent validation of variant
        :type variantValidation: None | VariantValidation
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.2.0"
